﻿using System;
using Microsoft.EntityFrameworkCore;
using System.ComponentModel.DataAnnotations;
using System.Collections.Generic;

namespace ScheduleSample.Model
{
    public partial class ScheduleDataContext : DbContext
    {
        public ScheduleDataContext(DbContextOptions<ScheduleDataContext> options)
            : base(options)
        { }

        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            modelBuilder.Entity<ScheduleAppointment>(entity =>
            {
                entity.Property(e => e.Id).IsRequired();
            });

        }
        public virtual DbSet<ScheduleAppointment> ScheduleAppointments { get; set; }
    }

    public class ScheduleAppointment
    {
        [Key]
        public int Id { get; set; }
        public string Subject { get; set; }
        public bool AllDay { get; set; }
        public bool Recurrence { get; set; }
        public DateTime StartTime { get; set; }
        public DateTime EndTime { get; set; }
        public string Description { get; set; }
        public string RecurrenceRule { get; set; }
    }

    public class EditParams
    {
        public string key { get; set; }
        public string action { get; set; }
        public List<ScheduleAppointment> added { get; set; }
        public List<ScheduleAppointment> changed { get; set; }
        public List<ScheduleAppointment> deleted { get; set; }
        public ScheduleAppointment value { get; set; }
    }
}
